package org.opengroup.osdu.notification.provider.azure.messageBus.extractor;


import com.microsoft.azure.servicebus.IMessage;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.opengroup.osdu.notification.provider.azure.messageBus.interfaces.IPullRequestBodyExtractor;
import org.opengroup.osdu.notification.provider.azure.messageBus.models.TopicSubscriptionsTest;
import org.opengroup.osdu.notification.provider.azure.models.NotificationContent;

import java.util.HashMap;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotNull;

@RunWith(MockitoJUnitRunner.class)
public class RequestBodyAdapterTest {

    @InjectMocks
    RequestBodyAdapter requestBodyAdapter;

    @Mock
    IPullRequestBodyExtractor extractor;

    @Mock
    IMessage message;

    @Before
    public void setup() {
        MockitoAnnotations.openMocks(RequestBodyAdapterTest.this);
    }

    @Test
    public void extractNotificationContentTest() {
        NotificationContent expected = new NotificationContent("recordsTopic",null,new HashMap<String,String>(),false);
        NotificationContent actual = requestBodyAdapter.extractNotificationContent(message,"recordsTopic");
        assertNotNull(actual);
        assertEquals(expected,actual);
        assertEquals(actual.getNotificationId(),"recordsTopic");
    }
}
